   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import java.net.*;
   import java.io.*;
   import java.io.File;
   import javax.swing.text.*;


   public class Artefakt extends JPanel {
   
      public static JFrame frame;
   
      private JMenuBar barMB;
      private JMenu artefakteAnlegenM;
      private JMenu benutzerAnlegenM;
      private JMenu fileM;
      private JMenuItem exitMI;
      private JMenuItem logoutMI;
      private JMenuItem neuesArtefaktAnlegenMI;
      private JMenuItem attributePflegenMI;
      private JTextField textField;   
   
   
      private ActionListener exitAL;
      private ActionListener logoutAL;
      private ActionListener neuesArtefaktAnlegenAL;
      private ActionListener attributePflegenAL;
   
      private mClient mc;
   
      private Connect c;
   
      private boolean connectionEstablished = false;
      private JPanel barPanel;
      private JPanel infoPanel;
      public Artefakt() {
      
         this.setLayout(new BorderLayout());
         infoPanel = new JPanel(new BorderLayout());
         barPanel = new JPanel(new FlowLayout());
         barMB = new JMenuBar();
         add(barMB, BorderLayout.NORTH);
         this.add(barPanel);
         this.add(infoPanel);
         artefakteAnlegenM = new JMenu("Artefakte Anlegen");
      
         fileM = new JMenu("File");
         barMB.add(fileM);
      
         logoutMI = new JMenuItem("Logout");
         fileM.add(logoutMI);
      
      
         exitMI = new JMenuItem("Exit");
         fileM.add(exitMI);
      
      
      
      
         neuesArtefaktAnlegenMI = new JMenuItem("Neues Artefakt Anlegen");
         artefakteAnlegenM.add(neuesArtefaktAnlegenMI);
      
         attributePflegenMI = new JMenuItem("Attribute Pflegen");
         artefakteAnlegenM.add(attributePflegenMI); 
      
      
         barMB.add(artefakteAnlegenM);
      
         benutzerAnlegenM = new JMenu("Benutzer Anlegen");
         barMB.add(benutzerAnlegenM);
      
      
      
         exitAL = new ExitAction();
         exitMI.addActionListener(exitAL);
      
         logoutAL = new LogoutAction();
         logoutMI.addActionListener(logoutAL);
      
         neuesArtefaktAnlegenAL = new ArtefaktAnlegenAction();
         neuesArtefaktAnlegenMI.addActionListener(neuesArtefaktAnlegenAL);
      
         attributePflegenAL = new AttributePflegenAction();
         attributePflegenMI.addActionListener(attributePflegenAL);
      
         this.setSize(800, 600);
         this.setVisible(true);
      }
   
      private class ExitAction implements ActionListener {
         public void actionPerformed(ActionEvent e) {
         
            if (connectionEstablished) {
               mc.closeConnection(); 
            }
            System.exit(0); 
         
         }
      }
   
      private class LogoutAction implements ActionListener {
         public void actionPerformed(ActionEvent e) {
         
            mc.closeConnection(); 
            connectionEstablished = false;
         
         }
      }
   
   
   
      private class ArtefaktAnlegenAction implements ActionListener{
         public void actionPerformed(ActionEvent e){
          //  try { // begin try
         
            if (!connectionEstablished) {
               c = new Connect(1);
            }
            else {
               System.out.println("There is a connection");
               SendData sd = new SendData(mc);
            
            }
           // }
           /*    catch (IOException a) { // begin catch
                  System.out.println("There was no connection to the Server! From the class ConnectAction");
                  //MessageFactory error_message = new MessageFactory("There was no connection to the server");          
                  JOptionPane.showMessageDialog(new JFrame(),
                                       "No Connection to the server",
                                       "Connection Error",
                                       JOptionPane.ERROR_MESSAGE);
               } // end catch*/ 
         } // end try
      }
   
      private class AttributePflegenAction implements ActionListener {
         public void actionPerformed(ActionEvent e) {
         
            System.out.println("Pflegen"); 
         
         
          /*  if(!connectionEstablished) {
               c = new Connect(2);
            }
            else {
               System.out.println("There is a connection");
               SendDataMaintain sdm = new SendDataMaintain(mc);
            }*/
         
         }
      }
   
   
   /** This class can be used to create an object which is used as a front mask to input a computer name and a port number
   * on which the server listens. Objects of this class are modal, that is, something must be done with this object first,
   * before some other action can be used from the main window.
   *@version 1.0
   *@author Huskic Zenon
   */
   
   
   
      private class Connect extends JDialog implements ActionListener { // begin class Connect  
      
         // variables declaration
         JButton connectJB;
         JButton cancelJB;
         JPanel contentJP;
         JPanel buttonPanelJP;
         JPanel textPanelJP;
         JTextField addressJTF;
         JTextField portJTF;
         String server_addressS = "pavian";
         String portS = "4444";
         int num;
         /** Creates connection mask window with two fields(computer name and port number). There are two buttons as well; one
      	  * to connect, and one to cancel. Pressing on connect will call the startC method in class StartClient.
      	  */
      
         private Connect(int number)  { // begin constructor connect action
         
            num = number;
            String[] addressPortNo;
            setModal(true);  
            contentJP = new JPanel(new BorderLayout());
            setTitle("Verbindung mit Server");
            setSize(300,200);
            setResizable(true);
            Insets insets = new Insets(1,1,1,1);
            setContentPane(contentJP);
            textPanelJP = new JPanel(new FlowLayout());
            addressJTF = new JTextField(server_addressS, 10);
            addressJTF.setEditable(true);
            textPanelJP.add(new JLabel("Geben Sie Rechnername ein:   "));
            textPanelJP.add(addressJTF);
            portJTF = new JTextField(portS, 10);
            portJTF.setEditable(true);
            textPanelJP.add(new JLabel("Geben Sie Portnummer ein:    "));
            textPanelJP.add(portJTF);
            contentJP.add("Center",textPanelJP);
            buttonPanelJP = new JPanel(new FlowLayout());
            connectJB = new JButton("Verbinden"); 
            connectJB.setMargin(insets);
            cancelJB = new JButton("Abbrechen"); 
            cancelJB.setMargin(insets);
            connectJB.addActionListener(this);
            cancelJB.addActionListener(this);  
            buttonPanelJP.add(connectJB);
            buttonPanelJP.add(cancelJB);
            contentJP.add("South", buttonPanelJP);
         
            this.addWindowListener(
                                 
                                    new WindowAdapter() {
                                    
                                    
                                       public void windowClosing(WindowEvent e) {
                                       
                                          dispose();
                                       
                                       }
                                    });
            this.show();	
         } // end constructor connect action
      
      
         // every class that implements ActionListner must have the following:
      
         public void actionPerformed(ActionEvent e) {
         
         
            if (e.getSource() == cancelJB) {
               System.out.println("Cancel pressed in connect");
            
               dispose();
            }
            
            else if (e.getSource() == connectJB) {
               server_addressS = addressJTF.getText();
               portS = portJTF.getText();
               System.out.println("Connecting to the host " + server_addressS + " on the port number: " + portS);
            
               try{
                  mc = new mClient(server_addressS, Integer.parseInt(portS));
                  connectionEstablished = mc.connEstablished();
                  this.dispose();
                  if (connectionEstablished) {
                     if(num == 1) {
                        SendData sd = new SendData(mc);
                     }
                     if(num == 2) {
                        SendDataMaintain sdm = new SendDataMaintain(mc);
                     }
                  }
               
               }
                  catch (IOException ex){
                  }
            // try {
            
               System.out.println("Before creating myClient in COnnect");
            
            
            }
         
         }
      }  
   
   
   
   
   
   
      public static void main (String s[]) 
      {
         frame = new JFrame();
         frame.setTitle("Client");
         System.out.println("before try in main");
      
         Artefakt artefakt = new Artefakt();      
      
         frame.getContentPane().add(artefakt);
         frame.setSize(200,300);
         frame.pack();
         frame.show();
      
         frame.addWindowListener(
                                 new WindowAdapter() {
                                    public void windowClosing(WindowEvent e) {
                                       System.out.println("Cleaning...");
                                    
                                       System.exit(0);
                                    }
                                 });
      
      
         System.out.println("after clientgui in main");
      } // end main
   
   }
