/*
***********************************
Author: Huskic Zenon
Matrikel No. : 9720359
PS Leiter: H. Linder
PS: Verteilte Systeme und Netze
Uebung 6 : Bsp4 (mServer.java)
Date: 12.11.1999
Last update: 13.11.1999
***********************************
Description:
This class is a Server side of the program. It uses
mProtocol.java class to communicate with mClient. Socket that
will be used is 4444.
In order to solve the problem of multiple clients using the 
same server threads can be used. 
*/
   import java.net.*;
   import java.io.*;

   public class mServer { // start class here
      public static void main(String[] args) throws IOException {
         ServerSocket serverSocket = null; // initalize the server socket
         boolean listening = true;
      
         try {
            serverSocket = new ServerSocket(4444);  // create new socket
         } 
            catch (IOException e) {
               System.err.println("Could not listen on port: 4444.");
               System.exit(-1);
            }
      
         while (listening) // create new server thread
            new mServerThread(serverSocket.accept()).start();
      
         serverSocket.close();
      }
   }
