/*
***********************************
Author: Huskic Zenon
Matrikel No. : 9720359
PS Leiter: H. Linder
PS: Verteilte Systeme und Netze
Uebung 6 : Bsp4 (mServerThread.java)
Date: 12.11.1999
Last update: 13.11.1999
***********************************
Description:
This class is Thread implementation for the multiple clients.
If one of the clients goes away, the server continues to work
with other clients.
*/

   import java.net.*;
   import java.io.*;

   public class mServerThread extends Thread {
      private Socket socket = null;
   
      public mServerThread(Socket socket) {
         super("mServerThread");
         this.socket = socket;
      }
   
      public void run() {
      
         try {
            PrintWriter out = new PrintWriter(socket.getOutputStream(), true);
            BufferedReader in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
         
            String inputLine, outputLine;
            mProtocol multiple_protocol = new mProtocol();
            outputLine = multiple_protocol.processInput(null);
            out.println(outputLine);
         
            while ((inputLine = in.readLine()) != null) {
               outputLine = multiple_protocol.processInput(inputLine);
               out.println(outputLine);
               if (outputLine.equals("bye"))
                  break;
            }
            out.close();
            in.close();
            socket.close();
         
         } 
            catch (IOException e) {
               e.printStackTrace();
            }
      }
   }